A Rectangle object is an area defined by its position, as indicated by its top-left corner point(_x_, _y_) and by its width and its height.

The `x`, `y`, `width`, and `height` properties of the Rectangle class are independent of each other; changing the value of one property has no effect on the others. However, the `right` and `bottom` properties are integrally related to those four properties. For example, if you change the value of the `right` property, the value of the `width` property changes; if you change the `bottom` property, the value of the `height` property changes.

The following methods and properties use Rectangle objects:

- The `applyFilter()`, `colorTransform()`, `copyChannel()`, `copyPixels()`, `draw()`, `fillRect()`, `generateFilterRect()`, `getColorBoundsRect()`, `getPixels()`, `merge()`, `paletteMap()`, `pixelDisolve()`, `setPixels()`, and `threshold()` methods, and the `rect` property of the BitmapData class
- The `getBounds()` and `getRect()` methods, and the `scrollRect` and `scale9Grid` properties of the DisplayObject class
- The `getCharBoundaries()` method of the TextField class
- The `pixelBounds` property of the Transform class
- The `bounds` parameter for the `startDrag()` method of the Sprite class
- The `printArea` parameter of the `addPage()` method of the PrintJob class

You can use the `new Rectangle()` constructor to create a Rectangle object.

Note: The Rectangle class does not define a rectangular Shape display object. To draw a rectangular Shape object onscreen, use the `drawRect()` method of the Graphics class.

### Hierarchy

- Rectangle

## Index

### Constructors

- constructor

### Properties

- bottom
- bottomRight
- height
- left
- right
- size
- top
- topLeft
- width
- x
- y

### Methods

- clone
- contains
- containsPoint
- containsRect
- copyFrom
- equals
- get_bottom
- get_bottomRight
- get_left
- get_right
- get_size
- get_top
- get_topLeft
- inflate
- inflatePoint
- intersection
- intersects
- isEmpty
- offset
- offsetPoint
- setEmpty
- setTo
- set_bottom
- set_bottomRight
- set_left
- set_right
- set_size
- set_top
- set_topLeft
- toString
- union

## Constructors

### constructor

- new Rectangle(x?: number, y?: number, width?: number, height?: number): Rectangle

- - Defined in lib/openfl/geom/Rectangle.d.ts:161

  Creates a new Rectangle object with the top-left corner specified by the `x` and `y` parameters and with the specified `width` and `height` parameters. If you call this function without parameters, a rectangle with `x`, `y`, `width`, and `height` properties set to 0 is created.

  #### Parameters

  - ##### Optional x: number

    The _x_ coordinate of the top-left corner of the rectangle.

  - ##### Optional y: number

    The _y_ coordinate of the top-left corner of the rectangle.

  - ##### Optional width: number

    The width of the rectangle, in pixels.

  - ##### Optional height: number

    The height of the rectangle, in pixels.

  #### Returns Rectangle

## Properties

### bottom

bottom: number

- Defined in lib/openfl/geom/Rectangle.d.ts:57

The sum of the `y` and `height` properties.

### bottomRight

bottomRight: Point

- Defined in lib/openfl/geom/Rectangle.d.ts:66

The location of the Rectangle object's bottom-right corner, determined by the values of the `right` and `bottom` properties.

### height

height: number

- Defined in lib/openfl/geom/Rectangle.d.ts:76

The height of the rectangle, in pixels. Changing the `height` value of a Rectangle object has no effect on the `x`, `y`, and `width` properties.

### left

left: number

- Defined in lib/openfl/geom/Rectangle.d.ts:88

The _x_ coordinate of the top-left corner of the rectangle. Changing the `left` property of a Rectangle object has no effect on the `y` and `height` properties. However it does affect the `width` property, whereas changing the `x` value does not affect the `width` property.

The value of the `left` property is equal to the value of the `x` property.

### right

right: number

- Defined in lib/openfl/geom/Rectangle.d.ts:96

The sum of the `x` and `width` properties.

### size

size: Point

- Defined in lib/openfl/geom/Rectangle.d.ts:105

The size of the Rectangle object, expressed as a Point object with the values of the `width` and `height` properties.

### top

top: number

- Defined in lib/openfl/geom/Rectangle.d.ts:120

The _y_ coordinate of the top-left corner of the rectangle. Changing the `top` property of a Rectangle object has no effect on the `x` and `width` properties. However it does affect the `height` property, whereas changing the `y` value does not affect the `height` property.

The value of the `top` property is equal to the value of the `y` property.

### topLeft

topLeft: Point

- Defined in lib/openfl/geom/Rectangle.d.ts:129

The location of the Rectangle object's top-left corner, determined by the _x_ and _y_ coordinates of the point.

### width

width: number

- Defined in lib/openfl/geom/Rectangle.d.ts:139

The width of the rectangle, in pixels. Changing the `width` value of a Rectangle object has no effect on the `x`, `y`, and `height` properties.

### x

x: number

- Defined in lib/openfl/geom/Rectangle.d.ts:150

The _x_ coordinate of the top-left corner of the rectangle. Changing the value of the `x` property of a Rectangle object has no effect on the `y`, `width`, and `height` properties.

The value of the `x` property is equal to the value of the `left` property.

### y

y: number

- Defined in lib/openfl/geom/Rectangle.d.ts:161

The _y_ coordinate of the top-left corner of the rectangle. Changing the value of the `y` property of a Rectangle object has no effect on the `x`, `width`, and `height` properties.

The value of the `y` property is equal to the value of the `top` property.

## Methods

### clone

- clone(): Rectangle

- - Defined in lib/openfl/geom/Rectangle.d.ts:191

  Returns a new Rectangle object with the same values for the `x`, `y`, `width`, and `height` properties as the original Rectangle object.

  #### Returns Rectangle

  A new Rectangle object with the same values for the `x`, `y`, `width`, and `height` properties as the original Rectangle object.

### contains

- contains(x: number, y: number): boolean

- - Defined in lib/openfl/geom/Rectangle.d.ts:203

  Determines whether the specified point is contained within the rectangular region defined by this Rectangle object.

  #### Parameters

  - ##### x: number

    The _x_ coordinate(horizontal position) of the point.

  - ##### y: number

    The _y_ coordinate(vertical position) of the point.

  #### Returns boolean

  A value of `true` if the Rectangle object contains the specified point; otherwise `false`.

### containsPoint

- containsPoint(point: Point): boolean

- - Defined in lib/openfl/geom/Rectangle.d.ts:217

  Determines whether the specified point is contained within the rectangular region defined by this Rectangle object. This method is similar to the `Rectangle.contains()` method, except that it takes a Point object as a parameter.

  #### Parameters

  - ##### point: Point

    The point, as represented by its _x_ and _y_ coordinates.

  #### Returns boolean

  A value of `true` if the Rectangle object contains the specified point; otherwise `false`.

### containsRect

- containsRect(rect: Rectangle): boolean

- - Defined in lib/openfl/geom/Rectangle.d.ts:231

  Determines whether the Rectangle object specified by the `rect` parameter is contained within this Rectangle object. A Rectangle object is said to contain another if the second Rectangle object falls entirely within the boundaries of the first.

  #### Parameters

  - ##### rect: Rectangle

    The Rectangle object being checked.

  #### Returns boolean

  A value of `true` if the Rectangle object that you specify is contained by this Rectangle object; otherwise `false`.

### copyFrom

- copyFrom(sourceRect: Rectangle): void

- - Defined in lib/openfl/geom/Rectangle.d.ts:234

  #### Parameters

  - ##### sourceRect: Rectangle

  #### Returns void

### equals

- equals(toCompare: Rectangle): boolean

- - Defined in lib/openfl/geom/Rectangle.d.ts:250

  Determines whether the object specified in the `toCompare` parameter is equal to this Rectangle object. This method compares the `x`, `y`, `width`, and `height` properties of an object against the same properties of this Rectangle object.

  #### Parameters

  - ##### toCompare: Rectangle

    The rectangle to compare to this Rectangle object.

  #### Returns boolean

  A value of `true` if the object has exactly the same values for the `x`, `y`, `width`, and `height` properties as this Rectangle object; otherwise `false`.

### Protected get_bottom

- get_bottom(): number

- - Defined in lib/openfl/geom/Rectangle.d.ts:59

  #### Returns number

### Protected get_bottomRight

- get_bottomRight(): Point

- - Defined in lib/openfl/geom/Rectangle.d.ts:68

  #### Returns Point

### Protected get_left

- get_left(): number

- - Defined in lib/openfl/geom/Rectangle.d.ts:90

  #### Returns number

### Protected get_right

- get_right(): number

- - Defined in lib/openfl/geom/Rectangle.d.ts:98

  #### Returns number

### Protected get_size

- get_size(): Point

- - Defined in lib/openfl/geom/Rectangle.d.ts:107

  #### Returns Point

### Protected get_top

- get_top(): number

- - Defined in lib/openfl/geom/Rectangle.d.ts:122

  #### Returns number

### Protected get_topLeft

- get_topLeft(): Point

- - Defined in lib/openfl/geom/Rectangle.d.ts:131

  #### Returns Point

### inflate

- inflate(dx: number, dy: number): void

- - Defined in lib/openfl/geom/Rectangle.d.ts:266

  Increases the size of the Rectangle object by the specified amounts, in pixels. The center point of the Rectangle object stays the same, and its size increases to the left and right by the `dx` value, and to the top and the bottom by the `dy` value.

  #### Parameters

  - ##### dx: number

    The value to be added to the left and the right of the Rectangle object. The following equation is used to calculate the new width and position of the rectangle:

  - ##### dy: number

    The value to be added to the top and the bottom of the Rectangle. The following equation is used to calculate the new height and position of the rectangle:

  #### Returns void

### inflatePoint

- inflatePoint(point: Point): void

- - Defined in lib/openfl/geom/Rectangle.d.ts:281

  Increases the size of the Rectangle object. This method is similar to the `Rectangle.inflate()` method except it takes a Point object as a parameter.

  The following two code examples give the same result:

  #### Parameters

  - ##### point: Point

    The `x` property of this Point object is used to increase the horizontal dimension of the Rectangle object. The `y` property is used to increase the vertical dimension of the Rectangle object.

  #### Returns void

### intersection

- intersection(toIntersect: Rectangle): Rectangle

- - Defined in lib/openfl/geom/Rectangle.d.ts:299

  If the Rectangle object specified in the `toIntersect` parameter intersects with this Rectangle object, returns the area of intersection as a Rectangle object. If the rectangles do not intersect, this method returns an empty Rectangle object with its properties set to 0.

  #### Parameters

  - ##### toIntersect: Rectangle

    The Rectangle object to compare against to see if it intersects with this Rectangle object.

  #### Returns Rectangle

  A Rectangle object that equals the area of intersection. If the rectangles do not intersect, this method returns an empty Rectangle object; that is, a rectangle with its `x`, `y`, `width`, and `height` properties set to 0.

### intersects

- intersects(toIntersect: Rectangle): boolean

- - Defined in lib/openfl/geom/Rectangle.d.ts:314

  Determines whether the object specified in the `toIntersect` parameter intersects with this Rectangle object. This method checks the `x`, `y`, `width`, and `height` properties of the specified Rectangle object to see if it intersects with this Rectangle object.

  #### Parameters

  - ##### toIntersect: Rectangle

    The Rectangle object to compare against this Rectangle object.

  #### Returns boolean

  A value of `true` if the specified object intersects with this Rectangle object; otherwise `false`.

### isEmpty

- isEmpty(): boolean

- - Defined in lib/openfl/geom/Rectangle.d.ts:323

  Determines whether or not this Rectangle object is empty.

  #### Returns boolean

  A value of `true` if the Rectangle object's width or height is less than or equal to 0; otherwise `false`.

### offset

- offset(dx: number, dy: number): void

- - Defined in lib/openfl/geom/Rectangle.d.ts:333

  Adjusts the location of the Rectangle object, as determined by its top-left corner, by the specified amounts.

  #### Parameters

  - ##### dx: number

    Moves the _x_ value of the Rectangle object by this amount.

  - ##### dy: number

    Moves the _y_ value of the Rectangle object by this amount.

  #### Returns void

### offsetPoint

- offsetPoint(point: Point): void

- - Defined in lib/openfl/geom/Rectangle.d.ts:343

  Adjusts the location of the Rectangle object using a Point object as a parameter. This method is similar to the `Rectangle.offset()` method, except that it takes a Point object as a parameter.

  #### Parameters

  - ##### point: Point

    A Point object to use to offset this Rectangle object.

  #### Returns void

### setEmpty

- setEmpty(): void

- - Defined in lib/openfl/geom/Rectangle.d.ts:354

  Sets all of the Rectangle object's properties to 0. A Rectangle object is empty if its width or height is less than or equal to 0.

  This method sets the values of the `x`, `y`, `width`, and `height` properties to 0.

  #### Returns void

### setTo

- setTo(xa: number, ya: number, widtha: number, heighta: number): void

- - Defined in lib/openfl/geom/Rectangle.d.ts:357

  #### Parameters

  - ##### xa: number

  - ##### ya: number

  - ##### widtha: number

  - ##### heighta: number

  #### Returns void

### Protected set_bottom

- set_bottom(value: number): number

- - Defined in lib/openfl/geom/Rectangle.d.ts:60

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_bottomRight

- set_bottomRight(value: Point): Point

- - Defined in lib/openfl/geom/Rectangle.d.ts:69

  #### Parameters

  - ##### value: Point

  #### Returns Point

### Protected set_left

- set_left(value: number): number

- - Defined in lib/openfl/geom/Rectangle.d.ts:91

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_right

- set_right(value: number): number

- - Defined in lib/openfl/geom/Rectangle.d.ts:99

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_size

- set_size(value: Point): Point

- - Defined in lib/openfl/geom/Rectangle.d.ts:108

  #### Parameters

  - ##### value: Point

  #### Returns Point

### Protected set_top

- set_top(value: number): number

- - Defined in lib/openfl/geom/Rectangle.d.ts:123

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_topLeft

- set_topLeft(value: Point): Point

- - Defined in lib/openfl/geom/Rectangle.d.ts:132

  #### Parameters

  - ##### value: Point

  #### Returns Point

### toString

- toString(): string

- - Defined in lib/openfl/geom/Rectangle.d.ts:360

  #### Returns string

### union

- union(toUnion: Rectangle): Rectangle

- - Defined in lib/openfl/geom/Rectangle.d.ts:374

  Adds two rectangles together to create a new Rectangle object, by filling in the horizontal and vertical space between the two rectangles.

  Note: The `union()` method ignores rectangles with `0` as the height or width value, such as: `var rect2:Rectangle = new Rectangle(300,300,50,0);`

  #### Parameters

  - ##### toUnion: Rectangle

    A Rectangle object to add to this Rectangle object.

  #### Returns Rectangle

  A new Rectangle object that is the union of the two rectangles.

Generated using TypeDoc